SparkleDigest (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.crypto.digests

## Class SparkleDigest

- java.lang.Object
- - org.bouncycastle.crypto.digests.SparkleDigest

- All Implemented Interfaces:
    Digest, ExtendedDigest

      public class SparkleDigest
      extends java.lang.Object

  Sparkle v1.2, based on the current round 3 submission, https://sparkle-lwc.github.io/ Reference C implementation: https://github.com/cryptolu/sparkle Specification: https://csrc.nist.gov/CSRC/media/Projects/lightweight-cryptography/documents/finalist-round/updated-spec-doc/sparkle-spec-final.pdf

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static interface` | `BufferBaseDigest.ProcessingBuffer`
    `protected static class` | `BufferBaseDigest.ProcessingBufferType`
    `static class` | `SparkleDigest.Friend`
    `static class` | `SparkleDigest.SparkleParameters`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.String` | `algorithmName`
    `protected int` | `BlockSize`
    `protected int` | `DigestSize`
    `protected byte[]` | `m_buf`
    `protected int` | `m_bufPos`
    `protected BufferBaseDigest.ProcessingBuffer` | `processor`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SparkleDigest(SparkleDigest.SparkleParameters sparkleParameters)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `doFinal(byte[] output, int outOff)` close the digest, producing the final digest value.
    `protected void` | `ensureSufficientInputBuffer(byte[] input, int inOff, int len)`
    `protected void` | `ensureSufficientOutputBuffer(byte[] output, int outOff)`
    `protected void` | `finish(byte[] output, int outOff)`
    `java.lang.String` | `getAlgorithmName()` return the algorithm name
    `int` | `getByteLength()` Return the size in bytes of the internal buffer the digest applies it's compression function to.
    `int` | `getDigestSize()` return the size, in bytes, of the digest produced by this message digest.
    `protected void` | `processBytes(byte[] input, int inOff)`
    `void` | `reset()` reset the digest back to it's initial state.
    `void` | `update(byte in)` update the message digest with a single byte.
    `void` | `update(byte[] input, int inOff, int len)` update the message digest with a block of bytes.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DigestSize

          protected int DigestSize

    - #### BlockSize

          protected int BlockSize

    - #### m_buf

          protected byte[] m_buf

    - #### m_bufPos

          protected int m_bufPos

    - #### algorithmName

          protected java.lang.String algorithmName

    - #### processor

          protected BufferBaseDigest.ProcessingBuffer processor

  - ### Constructor Detail

    - #### SparkleDigest

          public SparkleDigest(SparkleDigest.SparkleParameters sparkleParameters)

  - ### Method Detail

    - #### processBytes

          protected void processBytes(byte[] input,
                                      int inOff)

    - #### finish

          protected void finish(byte[] output,
                                int outOff)

    - #### reset

          public void reset()

      Description copied from interface: `Digest`
      reset the digest back to it's initial state.
      Specified by:
        `reset` in interface `Digest`

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      Description copied from interface: `Digest`
      return the algorithm name
      Specified by:
        `getAlgorithmName` in interface `Digest`
      Returns:
        the algorithm name

    - #### getDigestSize

          public int getDigestSize()

      Description copied from interface: `Digest`
      return the size, in bytes, of the digest produced by this message digest.
      Specified by:
        `getDigestSize` in interface `Digest`
      Returns:
        the size, in bytes, of the digest produced by this message digest.

    - #### getByteLength

          public int getByteLength()

      Description copied from interface: `ExtendedDigest`
      Return the size in bytes of the internal buffer the digest applies it's compression function to.
      Specified by:
        `getByteLength` in interface `ExtendedDigest`
      Returns:
        byte length of the digests internal buffer.

    - #### update

          public void update(byte in)

      Description copied from interface: `Digest`
      update the message digest with a single byte.
      Specified by:
        `update` in interface `Digest`
      Parameters:
        `in` - the input byte to be entered.

    - #### update

          public void update(byte[] input,
                             int inOff,
                             int len)

      Description copied from interface: `Digest`
      update the message digest with a block of bytes.
      Specified by:
        `update` in interface `Digest`
      Parameters:
        `input` - the byte array containing the data.
        `inOff` - the offset into the byte array where the data starts.
        `len` - the length of the data.

    - #### doFinal

          public int doFinal(byte[] output,
                             int outOff)

      Description copied from interface: `Digest`
      close the digest, producing the final digest value. The doFinal call leaves the digest reset.
      Specified by:
        `doFinal` in interface `Digest`
      Parameters:
        `output` - the array the digest is to be copied into.
        `outOff` - the offset into the out array the digest is to start at.

    - #### ensureSufficientInputBuffer

          protected void ensureSufficientInputBuffer(byte[] input,
                                                     int inOff,
                                                     int len)

    - #### ensureSufficientOutputBuffer

          protected void ensureSufficientOutputBuffer(byte[] output,
                                                      int outOff)